## cmocka-mocks 0.52.1

=== CMakeLists.txt ===
# SPDX-License-Identifier: MIT
cmake_minimum_required(VERSION 3.21)
include(cmake/ConfigureLibrary.cmake)
include(cmake/project.cmake) # redefining OUR cmake project functions
project(cmocka_mocks LANGUAGES C VERSION ${CMOCKA_MOCKS_VERSION})
project_set_environment()
project_set_version_variables()
project_add_documentation_target(
  TITLE
    "BaseOS Cmocka_mocks Documentation"
  MARKDOWN
    ${CMAKE_SOURCE_DIR}/documentation/documentation.md
)

list(APPEND CMAKE_PREFIX_PATH "${INSTALL_DIR}/usr/local/lib/cmake")

configureLibrary(cmocka_extensions "${CMOCKA_EXTENSIONS_URI}" "${CMOCKA_EXTENSIONS_REF}")

add_subdirectory(src)

if(PACKAGING)
  include(cmake/Packing.cmake)
endif(PACKAGING)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

add_subdirectory(mock_libc)
add_subdirectory(mock_libmnl)
add_subdirectory(mock_jsonc)
add_subdirectory(mock_openssl)

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "Config.cmake.in"
  "cmocka_mocksConfig.cmake"
  INSTALL_DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks
  PATH_VARS
    CMAKE_INSTALL_LIBDIR
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/cmocka_mocksConfig.cmake"
  DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks"
)

=== src/mock_jsonc/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
find_package(cmocka_extensions REQUIRED)
find_package(json-c REQUIRED)

add_library(
  mock_jsonc SHARED
  mock_jsonc.c
)

set_property(TARGET mock_jsonc PROPERTY POSITION_INDEPENDENT_CODE ON)

set_target_properties(
  mock_jsonc
  PROPERTIES
    SOVERSION ${CMOCKA_MOCKS_VERSION_MAJOR}
    VERSION ${CMOCKA_MOCKS_VERSION_MAJOR}.${CMOCKA_MOCKS_VERSION_MINOR}.${CMOCKA_MOCKS_VERSION_MICRO}
)

target_include_directories(
  mock_jsonc
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  PUBLIC
    $<INSTALL_INTERFACE:include/>
)

target_link_options(
 mock_jsonc
 PUBLIC
   -Wl,--wrap=json_object_new_object
   -Wl,--wrap=json_object_get
   -Wl,--wrap=json_object_put
   -Wl,--wrap=json_object_is_type
   -Wl,--wrap=json_object_get_type
   -Wl,--wrap=json_object_to_json_string
   -Wl,--wrap=json_object_to_json_string_ext
   -Wl,--wrap=json_object_to_json_string_length
   -Wl,--wrap=json_object_get_userdata
   -Wl,--wrap=json_object_set_userdata
   -Wl,--wrap=json_object_set_serializer
   -Wl,--wrap=json_object_get_object
   -Wl,--wrap=json_object_object_length
   -Wl,--wrap=json_object_object_add
   -Wl,--wrap=json_object_object_add_ex
   -Wl,--wrap=json_object_object_get
   -Wl,--wrap=json_object_object_get_ex
   -Wl,--wrap=json_object_object_del
   -Wl,--wrap=json_object_new_array
   -Wl,--wrap=json_object_new_array_ext
   -Wl,--wrap=json_object_get_array
   -Wl,--wrap=json_object_array_length
   -Wl,--wrap=json_object_array_add
   -Wl,--wrap=json_object_array_put_idx
   -Wl,--wrap=json_object_array_get_idx
   -Wl,--wrap=json_object_array_del_idx
   -Wl,--wrap=json_object_array_shrink
   -Wl,--wrap=json_object_new_boolean
   -Wl,--wrap=json_object_get_boolean
   -Wl,--wrap=json_object_set_boolean
   -Wl,--wrap=json_object_new_int
   -Wl,--wrap=json_object_new_int64
   -Wl,--wrap=json_object_new_uint64
   -Wl,--wrap=json_object_get_int
   -Wl,--wrap=json_object_set_int
   -Wl,--wrap=json_object_int_inc
   -Wl,--wrap=json_object_get_int64
   -Wl,--wrap=json_object_get_uint64
   -Wl,--wrap=json_object_set_int64
   -Wl,--wrap=json_object_set_uint64
   -Wl,--wrap=json_object_new_double
   -Wl,--wrap=json_object_new_double_s
   -Wl,--wrap=json_c_set_serialization_double_format
   -Wl,--wrap=json_object_double_to_json_string
   -Wl,--wrap=json_object_get_double
   -Wl,--wrap=json_object_set_double
   -Wl,--wrap=json_object_new_string
   -Wl,--wrap=json_object_new_string_len
   -Wl,--wrap=json_object_get_string
   -Wl,--wrap=json_object_get_string_len
   -Wl,--wrap=json_object_set_string
   -Wl,--wrap=json_object_set_string_len
   -Wl,--wrap=json_object_new_null
   -Wl,--wrap=json_object_equal
   -Wl,--wrap=json_object_deep_copy
   -Wl,--wrap=json_tokener_parse
   -Wl,--wrap=json_object_from_file
   -Wl,--wrap=json_util_get_last_err
)

target_link_libraries(
  mock_jsonc
  PRIVATE
    cmocka
    cmocka_extensions::cmocka_extensions
    json-c::json-c
)

install(
  EXPORT mock_jsoncTargets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks
  NAMESPACE cmocka_mocks::
  FILE mock_jsoncTargets.cmake # Not sure if this is still needed
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/mock_jsoncConfigVersion.cmake
  VERSION ${PKG_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/mock_jsoncConfigVersion.cmake"
  DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks"
)

install(TARGETS mock_jsonc EXPORT mock_jsoncTargets  DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/mock_libc/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
find_package(cmocka_extensions REQUIRED)

add_library(
  mock_libc SHARED
  mock_libc.c
)

set_property(TARGET mock_libc PROPERTY POSITION_INDEPENDENT_CODE ON)

set_target_properties(
  mock_libc
  PROPERTIES
    SOVERSION ${CMOCKA_MOCKS_VERSION_MAJOR}
    VERSION ${CMOCKA_MOCKS_VERSION_MAJOR}.${CMOCKA_MOCKS_VERSION_MINOR}.${CMOCKA_MOCKS_VERSION_MICRO}
)

target_include_directories(
  mock_libc
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  PUBLIC
    $<INSTALL_INTERFACE:include/>
)

target_link_options(
 mock_libc
 PUBLIC
    -Wl,--wrap=malloc
    -Wl,--wrap=realloc
    -Wl,--wrap=calloc
    -Wl,--wrap=free
    -Wl,--wrap=memcpy
    -Wl,--wrap=strdup
    -Wl,--wrap=fopen
    -Wl,--wrap=fdopen
    -Wl,--wrap=fclose
    -Wl,--wrap=fwrite
    -Wl,--wrap=fread
    -Wl,--wrap=fseek
    -Wl,--wrap=scandir
    -Wl,--wrap=access
    -Wl,--wrap=fseek
    -Wl,--wrap=rewind
    -Wl,--wrap=ftell
    -Wl,--wrap=popen
    -Wl,--wrap=pclose
    -Wl,--wrap=getline
    -Wl,--wrap=getenv
    -Wl,--wrap=getpid
    -Wl,--wrap=opendir
    -Wl,--wrap=closedir
    -Wl,--wrap=remove
    -Wl,--wrap=readdir
    -Wl,--wrap=stat
    -Wl,--wrap=fputc
    -Wl,--wrap=time
    -Wl,--wrap=clock_gettime
    -Wl,--wrap=inet_aton
    -Wl,--wrap=inet_pton
    -Wl,--wrap=getaddrinfo
    -Wl,--wrap=freeaddrinfo
    -Wl,--wrap=socket
    -Wl,--wrap=setsockopt
    -Wl,--wrap=accept
    -Wl,--wrap=connect
    -Wl,--wrap=bind
    -Wl,--wrap=listen
    -Wl,--wrap=close
    -Wl,--wrap=open
    -Wl,--wrap=regerror
    -Wl,--wrap=regexec
    -Wl,--wrap=regcomp
    -Wl,--wrap=strndup
    -Wl,--wrap=raise
    -Wl,--wrap=pselect
    -Wl,--wrap=pthread_create
    -Wl,--wrap=pthread_join
    -Wl,--wrap=pthread_once
    -Wl,--wrap=pthread_mutex_init
    -Wl,--wrap=pthread_mutex_destroy
    -Wl,--wrap=pthread_mutex_trylock
    -Wl,--wrap=pthread_mutex_lock
    -Wl,--wrap=pthread_mutex_unlock
    -Wl,--wrap=pthread_mutex_timedlock
    -Wl,--wrap=pthread_setname_np
    -Wl,--wrap=sem_init
    -Wl,--wrap=sem_post
    -Wl,--wrap=sem_destroy
    -Wl,--wrap=sem_timedwait
    -Wl,--wrap=eventfd
    -Wl,--wrap=eventfd_read
    -Wl,--wrap=eventfd_write
)

target_link_libraries(
  mock_libc
  PRIVATE
    cmocka
    cmocka_extensions::cmocka_extensions
)

install(
  EXPORT mock_libcTargets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks
  NAMESPACE cmocka_mocks::
  FILE mock_libcTargets.cmake # Not sure if this is still needed
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/mock_libcConfigVersion.cmake
  VERSION ${PKG_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/mock_libcConfigVersion.cmake"
  DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks"
)

install(TARGETS mock_libc EXPORT mock_libcTargets  DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/mock_libmnl/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
find_package(cmocka_extensions REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBMNL REQUIRED libmnl)

add_library(
  mock_libmnl SHARED
  mock_libmnl.c
)

set_property(TARGET mock_libmnl PROPERTY POSITION_INDEPENDENT_CODE ON)

set_target_properties(
  mock_libmnl
  PROPERTIES
    SOVERSION ${CMOCKA_MOCKS_VERSION_MAJOR}
    VERSION ${CMOCKA_MOCKS_VERSION_MAJOR}.${CMOCKA_MOCKS_VERSION_MINOR}.${CMOCKA_MOCKS_VERSION_MICRO}
)

target_link_options(
  mock_libmnl
  PUBLIC
    -Wl,--wrap=mnl_socket_open
    -Wl,--wrap=mnl_socket_bind
    -Wl,--wrap=mnl_socket_close
    -Wl,--wrap=mnl_socket_recvfrom
    -Wl,--wrap=mnl_socket_sendto
    -Wl,--wrap=mnl_socket_get_portid
)

target_include_directories(
  mock_libmnl
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  PUBLIC
    $<INSTALL_INTERFACE:include/>
)

target_link_libraries(
  mock_libmnl
  PRIVATE
    cmocka
    cmocka_extensions::cmocka_extensions
    ${LIBMNL_LIBRARIES}
)

install(
  EXPORT mock_libmnlTargets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks
  NAMESPACE cmocka_mocks::
  FILE mock_libmnlTargets.cmake # Not sure if this is still needed
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/mock_libmnlConfigVersion.cmake
  VERSION ${PKG_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/mock_libmnlConfigVersion.cmake"
  DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks"
)

install(TARGETS mock_libmnl EXPORT mock_libmnlTargets  DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/mock_openssl/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
find_package(cmocka_extensions REQUIRED)
find_package(OpenSSL REQUIRED)

add_library(
  mock_openssl SHARED
  mock_openssl.c
)

set_property(TARGET mock_openssl PROPERTY POSITION_INDEPENDENT_CODE ON)

set_target_properties(
  mock_openssl
  PROPERTIES
    SOVERSION ${CMOCKA_MOCKS_VERSION_MAJOR}
    VERSION ${CMOCKA_MOCKS_VERSION_MAJOR}.${CMOCKA_MOCKS_VERSION_MINOR}.${CMOCKA_MOCKS_VERSION_MICRO}
)

target_link_options(
  mock_openssl
  PUBLIC
    -Wl,--wrap=PEM_read_PUBKEY
    -Wl,--wrap=EVP_MD_CTX_new
    -Wl,--wrap=EVP_MD_CTX_create
    -Wl,--wrap=EVP_MD_fetch
    -Wl,--wrap=EVP_get_digestbyname
    -Wl,--wrap=EVP_DecodeBlock
    -Wl,--wrap=EVP_DigestVerifyInit
    -Wl,--wrap=EVP_DigestUpdate
    -Wl,--wrap=EVP_DigestVerifyFinal
    -Wl,--wrap=EVP_PKEY_free
    -Wl,--wrap=EVP_MD_free
    -Wl,--wrap=EVP_MD_CTX_free
    -Wl,--wrap=EVP_MD_CTX_destroy
)

target_include_directories(
  mock_openssl
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
  PUBLIC
    $<INSTALL_INTERFACE:include/>
)

target_link_libraries(
  mock_openssl
  PRIVATE
    cmocka
    cmocka_extensions::cmocka_extensions
    OpenSSL::Crypto
)

install(
  EXPORT mock_opensslTargets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks
  NAMESPACE cmocka_mocks::
  FILE mock_opensslTargets.cmake # Not sure if this is still needed
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/mock_opensslConfigVersion.cmake
  VERSION ${PKG_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/mock_opensslConfigVersion.cmake"
  DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/cmocka_mocks"
)

install(TARGETS mock_openssl EXPORT mock_opensslTargets  DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
cmocka-mocks (0.52.1-0ubuntu1) oracular; urgency=medium

  * Initial release (LP: #2069875).
    Based on upstream debian.native directory
    - debian: set cmocka-mocks section to devel.
    - debian: set cmocka-mocks-doc section to doc.
    - debian: set libcmocka-mocks-dev section to libdevel.
    - debian: update maintainer to Ubuntu Developers.
    - debian: remove vcs fields from control file.
      As these information won't be necessarly valid anymore if uploaded to
      Ubuntu.
    - debian: introduce debian/clean.
    - debian: generating doc only for Indep.
      This is optimizing build since doc package is specified for Architecture:all
    - debian: fix pkgconfig package name.
      W: cmocka-mocks source: build-depends-on-obsolete-package Build-Depends:
      pkg-config => pkgconf
    - debian: fix cmocka-mocks-doc.lintian-overrides.
    - debian: fix extended-description-is-probably-too-short.
    - debian: fix lintian-overrides lib versions.
    - debian: fix elektrobit namet  in copyright file.
    - Use dh_installdocs for the docs.
    - Remove the build 'all' option for arch builds.
    - Drop all libmock packages containing shared libraries.
    - Add static version of libmock into the dev package.

 -- Alexandre Esse <alexandre.esse@canonical.com>  Thu, 27 Jun 2024 16:13:27 +0200

=== debian/control ===
Source: cmocka-mocks
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Isaac True <isaac.true@emlix.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 git,
 libcmocka-dev,
 cmocka-extensions-dev,
 libmnl-dev,
 libjson-c-dev,
 pkgconf,
 libssl-dev,
Build-Depends-Indep:
 pandoc,
 pandoc-plantuml-filter,
 graphviz,
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Homepage: https://github.com/Elektrobit/cmocka_mocks

Package: libcmocka-mocks-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 cmocka-extensions-dev,
Suggests: cmocka-mocks-doc
Description: Library to mock common C functions for testing purposes
 Library to mock common C functions, like libc and jsonc, for testing purposes.
 This collection of ready to use mocks is based on cmocka_extensions.
 .
 Development package.

Package: cmocka-mocks-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Description: Documentation for cmocka-mocks
 Library to mock common C functions, like libc and jsonc, for testing purposes.
 This collection of ready to use mocks is based on cmocka_extensions.
 .
 Documentation package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --builddirectory=debian/build

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	dh_auto_build -- all cmocka_mocks_doc

override_dh_install:
	dh_install
	# Do not ship plantuml source files
	find debian/ -name \*.plantuml -delete

override_dh_compress:
	# Do not compress .md files
	dh_compress --exclude=.md

=== debian/watch ===
version=4
https://github.com/Elektrobit/cmocka_mocks/tags .*/cmocka_mocks-(\d+).(\d+).(\d+).tar.gz
